CREATE TABLE Indexed(
    IndexComplete INTEGER,
    IssueId TEXT,
    PRIMARY KEY (IssueId)
);

CREATE TABLE Layout(
    LayoutCode TEXT,
    Detail TEXT,
    PRIMARY KEY (LayoutCode)
);

CREATE TABLE Page(
    IssueId TEXT,
    Path TEXT,
    PageName TEXT,
    PreviewPath TEXT,
    PRIMARY KEY (IssueId, Path),
    FOREIGN KEY (IssueId) REFERENCES Indexed(IssueId) ON DELETE CASCADE
);

CREATE TABLE Text(
    IssueId TEXT,
    Path TEXT,
    PdfPath TEXT,
    IndexInPdf INTEGER,
    RootPath TEXT,
    RootIssueId TEXT,
    PRIMARY KEY (IssueId,Path),
    FOREIGN KEY (RootIssueId,RootPath) REFERENCES Page(IssueId,Path) ON DELETE CASCADE
);

CREATE VIRTUAL TABLE TextContent USING fts4();





CREATE TRIGGER Indexed_DELETE AFTER DELETE ON Indexed
BEGIN
    DELETE FROM Page WHERE Page.IssueId = OLD.rowid;
END;

CREATE TRIGGER Text_DELETE AFTER DELETE ON Text
BEGIN
DELETE FROM TextContent WHERE TextContent.rowid = OLD.rowid;
END;

INSERT INTO Layout(LayoutCode,Detail) VALUES ("B","Both");

INSERT INTO Layout(LayoutCode,Detail) VALUES ("H","Horizontal");

INSERT INTO Layout(LayoutCode,Detail) VALUES ("V","Vertical");